/* Izmenjen program 1.c tako da prikazuje KAKO NE TREBA koristiti
   argumente niti. U vise pokretanja programa moze se videti da je 
   sadrzaj promenljive *num nepredvidiv, jer je ova promenljiva 
   zajednicka za sve niti.*/
#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>

#define NUM_THREADS 20

void error_fatal(char *message)
{
  perror(message);
  exit (EXIT_FAILURE);
}

/* Posebna funkcija koja se poziva kada dodje do greske pri radu sa
   nitima. */
void pthread_error(char *message, int err)
{
  /* Funkcija strerror na osnovu vrednosti celobrojnog koda greske
     vraca pokazivac na string koji detaljnije opisuje gresku. */
  fprintf(stderr, "%s : %s\n", message, strerror(err));
  exit (EXIT_FAILURE);
}

void* fun(void *arg)
{
  pthread_t tid = pthread_self();
  /* Najcesce je pthread_t implementiran da bude unsigned int, pa
     radimo kastovanje i pokusavamo da ispisemo thread id. Ovo nije
     portabilan nacin da se ispise thread id, ali ce na vecini
     implementacija raditi. */
  printf("thread index: %-3d,\ttid: %-8u,\tpid: %d\n", *((int*)arg), (unsigned int)tid, getpid());
  return ((void*)0);
}

int main()
{
  int err;
  int i;
  pthread_t tid;
  int *num;

  /* Dinamicki se alocira prostor za promenljivu koju ce koristiti sve
     niti. */
  num = (int*)malloc(sizeof(int));
  if(num == NULL)
    error_fatal ("malloc error");

  for(i = 0; i < NUM_THREADS; i++)
  {
    *num = i;

    /* Kreiranje niti. Do greske moze doci ako se na primer kreira
       preveliki broj niti (probati sa hiljadama niti. Kod niti se
       status greske cuva u povratnoj vrednosti, ne postavlja se
       promenljiva errno, pa se koristi posebna funkcija za ispis
       greske. */
    if( (err = pthread_create(&tid, NULL, fun, num)) != 0)
      pthread_error ("create thread error", err);
  }

  /* Glavni program ceka da se sve niti zavrse. U suprotnom bi moglo
     da se desi da se main završi pre ostalih niti, pa bi mogao ceo
     proces da se završi pre nego što su neke niti i
     pokrenute. Koriscenje sleep funkcije nije dobar nacin da se ovo
     uradi, pogledati naredni primer. */
  sleep(3);
  printf ("The end of main function, pid : %d.\n", getpid());

  free (num);
  return 0;
}
